from aiohttp import web

from singleton import Singleton
from services.basicservice import BasicService


class BackBySale(BasicService, metaclass=Singleton):
    def __init__(self):
        super().__init__(__file__)
        self._loadAllCases()

    def getRoutes(self) -> list[web.AbstractRouteDef]:
        return [web.get('/CSrest/rest/sales/document/{docid}', handler=self.sales),
                web.get('/CSrest/rest/sales/document/{docid}/withreturned', handler=self.salesWithreturned)]

    async def sales(self, request: web.Request) -> web.Response:
        self.log.info(f"Запрос документа с идентификатором '{request.match_info['docid']}'")
        return self._createResponse(request.path)
    
    async def salesWithreturned(self, request: web.Request) -> web.Response:
        self.log.info(f"Запрос документа с идентификатором '{request.match_info['docid']}' и возвратов по нему")
        return self._createResponse(request.path)


instance = BackBySale()
