from aiohttp import web

from singleton import Singleton
from services.basicservice import BasicService


class Dolyame(BasicService, metaclass=Singleton):
    def __init__(self):
        super().__init__(__file__)
        self._loadCases("dolyame.json")

    def getRoutes(self) -> list[web.AbstractRouteDef]:
        return [web.post('/dolyame/create', handler=self.create),
                web.get('/dolyame/{orderId}/info', handler=self.info),
                web.post('/dolyame/{orderId}/cancel', handler=self.cancel),
                web.post('/dolyame/{orderId}/refund', handler=self.refund)]

    async def create(self, request: web.Request) -> web.Response:
        self.log.info("Создание заказа")
        self._loadCases("dolyame.json")
        return self._createResponse(request.path)

    async def info(self, request: web.Request) -> web.Response:
        self.log.info(f"Получение информации по заказу '{request.match_info['orderId']}'")
        return self._createResponse('/dolyame/<orderId>/info')

    async def cancel(self, request: web.Request) -> web.Response:
        self.log.info(f"Отмена заказа '{request.match_info['orderId']}'")
        return self._createResponse('/dolyame/<orderId>/cancel')

    async def refund(self, request: web.Request) -> web.Response:
        self.log.info(f"Возврат по заказу '{request.match_info['orderId']}'")
        return self._createResponse('/dolyame/<orderId>/refund')


instance = Dolyame()
