from aiohttp import web

from services.basicservice import BasicService
from singleton import Singleton


class FindFace(BasicService, metaclass=Singleton):

    def __init__(self):
        super().__init__(__file__)
        self._loadCases('findface.json')

    def getRoutes(self) -> list[web.AbstractRouteDef]:
        return [web.post('/auth/login/', handler=self.login),
                web.post('/auth/login', handler=self.login),
                web.post('/events/faces/add/', handler=self.add),
                web.post('/events/faces/add', handler=self.add),
                web.get('/config.json', handler=self.config)]

    async def login(self, request: web.Request) -> web.Response:
        self.log.info("Авторизация")
        return self._createResponse(request.path.removesuffix('/'))

    async def add(self, request: web.Request) -> web.Response:
        self.log.info("Распознавание")
        return self._createResponse(request.path.removesuffix('/'))

    async def config(self, request: web.Request) -> web.Response:
        self.log.info("Получение конфигурации")
        return self._createResponse(request.path)

instance = FindFace()
