from aiohttp import web

from singleton import Singleton
from services.basicservice import BasicService


class Lmchz(BasicService, metaclass=Singleton):
    def __init__(self):
        super().__init__(__file__)
        self._loadAllCases()

    def getRoutes(self) -> list[web.AbstractRouteDef]:
        return [web.post('/api/v1/init', handler=self.init),
                web.get('/api/v1/status', handler=self.status),
                web.post('/api/v1/cis/outCheck', handler=self.check)]

    async def init(self, request: web.Request) -> web.Response:
        self.log.info('Инициализация')
        return self._createResponse(request.path)

    async def status(self, request: web.Request) -> web.Response:
        self.log.info('Получение статуса')
        return self._createResponse(request.path)

    async def check(self, request: web.Request) -> web.Response:
        self.log.info('Проверка КИ')
        return self._createResponse(request.path)


instance = Lmchz()
