from aiohttp import web
import xml.etree.ElementTree as ET

from services.basicservice import BasicService
from singleton import Singleton


class Loymax(BasicService, metaclass=Singleton):
    def __init__(self):
        super().__init__(__file__)
        self._loadCases('cases.json')

    def getRoutes(self) -> list[web.AbstractRouteDef]:
        return [web.post('/loymax', handler=self.handler)]

    async def handler(self, request: web.Request) -> web.Response:
        root = ET.fromstring(await request.text())
        action = "undefined"

        if root.find(".//Balances"):
            action = "Balances"
        elif root.find(".//Calculates"):
            action = "Calculates"
        elif root.find(".//Discounts"):
            action = "Discounts"
        elif root.find(".//ConfirmPurchases"):
            action = "ConfirmPurchases"
        elif root.find(".//CancelPurchases"):
            action = "CancelPurchases"
        elif root.find(".//Payments"):
            action = "Payments"
        elif root.find(".//Refunds"):
            action = "Refunds"
        elif root.find(".//AvailableAmounts"):
            action = "AvailableAmounts"
        elif root.find(".//CancelOperations"):
            action = "CancelOperations"

        self.log.info(f"Действие: {action}")
        return self._createResponse(action)


instance = Loymax()
