from aiohttp import web

from services.basicservice import BasicService
from singleton import Singleton


class PriceChecker(BasicService, metaclass=Singleton):
    def __init__(self):
        super().__init__(__file__)
        self._loadCases('pricechecker.json')

    def getRoutes(self) -> list[web.AbstractRouteDef]:
        return [web.get('/CSrest/rest/checkers/messages/artix', handler=self.getPrice)]

    async def getPrice(self, request: web.Request) -> web.Response:
        self.log.info("Получение информации о товаре по штрих-коду")
        barcode = request.query.get('barcode', '')
        return self._createResponse(request.path, barcode if self._hasCases(request.path, barcode) else '<barcode>')


instance = PriceChecker()
