from aiohttp import web

from services.basicservice import BasicService
from singleton import Singleton


class SberSbp(BasicService, metaclass=Singleton):
    def __init__(self):
        super().__init__(__file__)
        self._loadAllCases()

    def getRoutes(self) -> list[web.AbstractRouteDef]:
        return [web.post('/tokens/v2/oauth', handler=self.token),
                web.post('/qr/order/v3/status', handler=self.status),
                web.post('/qr/order/v3/creation', handler=self.creation),
                web.post('/qr/order/v3/cancel', handler=self.cancel)]

    async def token(self, request: web.Request) -> web.Response:
        self.log.info("Запрос токена")
        return self._createResponse(request.path)

    async def status(self, request: web.Request) -> web.Response:
        self.log.info("Запрос статуса")
        return self._createResponse(request.path)

    async def creation(self, request: web.Request) -> web.Response:
        self.log.info("Создание заказа")
        return self._createResponse(request.path)

    async def cancel(self, request: web.Request) -> web.Response:
        self.log.info("Отмена оплаты")
        return self._createResponse(request.path)


instance = SberSbp()
