from aiohttp import web
from services.basicservice import BasicService

from singleton import Singleton


class Waybill(BasicService, metaclass=Singleton):
    def __init__(self):
        super().__init__(__file__)
        self._loadCases('waybill.json')

    def getRoutes(self) -> list[web.AbstractRouteDef]:
        return [web.post('/waybillNumbers/next', handler=self.getNumber)]

    async def getNumber(self, request: web.Request) -> web.Response:
        self.log.info('Получение номера УПД')
        return self._createResponse(request.path)


instance = Waybill()
